<!DOCTYPE html>
<html>

<head>
	<meta charset="utf-8">
	</meta>
	<link rel="stylesheet" type="text/css" href="../../css/style.css">
	<script src="../../js/jquery.js"></script>
	<link rel="icon" type="image/png" href="../../img/icon.png" />
	<script src="js/bootstrap.min.js"></script>
	<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.0/css/all.css"
		integrity="sha384-lZN37f5QGtY3VHgisS14W3ExzMWZxybE1SJSEsQp9S+oqd12jhcu+A56Ebc1zFSJ" crossorigin="anonymous">
	<title></title>
</head>

<body style="overflow-y: hidden">
	<div class="close_level_div"><a class="close_level" href="../level_select.html"><i
				class="fas fa-times-circle fa-3x back_level"></i></a></div>
	<img class="image-container image-blur" id="img"></img>
	<div class="button-group">
		<button class="btn-hidden" id="myBtn"></button>
	</div>
	<p class="mentions">Powered by IUT BORDEAUX & Tobii Gaming</p>

	<div id="myModal" class="modal">

		<!-- Modal content -->
		<div class="modal-content">
			<h2>ATTENTION :</h2>
			<p class="regles">Afin que le jeu fonctionne, veuillez mettre le navigateur en plein écran. Appuyez sur la
				touche "F11" de votre clavier.</p>
			<br><br>
			<img width="100" src="../../img/f11.png" />
			<br><br>
			<div id="loader"></div>
			<div id="errorMessage"></div>
			<br>
			<button id="btn_launch" class="close btn_start">LANCER</button>
		</div>
	</div>
	<div id="sucessModal" class="modal">
		<div class="modal-content" style="width: 70%">
			<div class="titre_modal">FELICITATIONS</div>
			<br />
			<div style="display: flex;">
				<div class="success-group">
					<img id="character"></img>
					<p id="duration"></p>
					<p id="durationAvg">Moyenne : ?</p>
				</div>
				<div class="success-group" style="justify-content: center;">
					<div style="max-height: 285px;overflow-y: auto;">
						<table class="table table-striped table-dark" style="width: 350px">
							<thead>
								<tr>
									<th scope="col">#</th>
									<th scope="col">Nom</th>
									<th scope="col">Score</th>
								</tr>
							</thead>
							<tbody id="add_row"></tbody>
						</table>
					</div><br>
				</div>
				<div class="success-group">
					<img id="charlieFind" class="charlieFind-img"></img>
					<p id="distance"></p>
					<p id="distanceAvg"></p>
				</div>
			</div><br>
			</grid>
			<div style="display:flex;justify-content: space-between;">
				<button id="back"><i class="fas fa-long-arrow-alt-left"></i>&nbsp; Retour a la selection des
					niveaux</button>
					<button id="changePerso">&nbsp; Changer de personnage</button>
						<button id="changePlayer">&nbsp; Retour à l'acceuil</button>
				<button id="next">Niveau suivant&nbsp;<i class="fas fa-long-arrow-alt-right"></i></button>
			</div>
		</div>
	</div>
	<script>

		const baseClassement = "{\"niveaux\": [[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[],[]]}";
		var nbLvl = document.URL.split('?')[1].split('=')[1];
		var numberNbLvl = Number(nbLvl);
		var nbLvlP1 = Number(nbLvl) + 1;
		var isFelicie = localStorage.getItem('carac') == 'felicie';

		if(nbLvl == 20) {
			$('#next').hide();
		}

		if (isFelicie) {
			if (!localStorage.getItem('classementF')) {
				localStorage.setItem('classementF', baseClassement);
			}
		} else {
			if (!localStorage.getItem('classementC')) {
				localStorage.setItem('classementC', baseClassement);
			}
		}

		var classementLvl = JSON.parse(localStorage.getItem(isFelicie ? 'classementF' : 'classementC'));

		function addScore(score, time) {
			if (!localStorage.getItem('name')) {
				localStorage.setItem('name', 'unknow')
			}
			classementLvl.niveaux[numberNbLvl - 1].push({ nom: localStorage.getItem('name'), score: score, time: time });
			sortScore();
			localStorage.setItem(isFelicie ? 'classementF' : 'classementC', JSON.stringify(classementLvl));
			updateScore();
		}

		var tabPlayers = classementLvl.niveaux[numberNbLvl - 1];
		function updateScore() {
			var row = document.getElementById('add_row');
			var total = 0, totalTime = 0;
			row.innerHTML = '';
			for (let player of tabPlayers) {
				var td = document.createElement("tr");
				td.innerHTML = "<th scope='row'>" + (Number(tabPlayers.indexOf(player)) + 1) + "</th><td>" + player.nom + "</td><td>" + player.score + "</td>";
				total += parseInt(player.score);
				totalTime += parseInt(player.time);
				row.append(td);
			}
			if(total > 0){
				$('#distanceAvg').html('Moyenne : ' + Math.round(total/tabPlayers.length) + ' Pixels');
			}
			if(totalTime > 0){
				$('#durationAvg').html('Moyenne : ' + Math.round(totalTime/tabPlayers.length) + ' Secondes');
			}
		}
		function sortScore() {
			tabPlayers.sort((a, b) => {
				return a.score - b.score;
			});
		}
		updateScore();
		sortScore();

		var nbLvlSrc = "../../img/level/c" + nbLvl + ".png";
		var nodeJsConnected = false;
		document.getElementById('back').addEventListener('click', () => {
			document.location.href = "../level_select.html";
		});

		document.getElementById('changePerso').addEventListener('click', () => {
			document.location.href = "../character.html";
		});

		document.getElementById('changePlayer').addEventListener('click', () => {
			document.location.href = "../../index.html";
		});

		document.getElementById('next').addEventListener('click', () => {
			document.location.href = "./lvl.html?lvl=" + (nbLvlP1);
		});
		var character = "../../img/" + localStorage.carac + ".jpg";
		var isCharlie = localStorage.carac === "charlie"
		var charlieFind = "../../img/charlie/c" + nbLvl + ".png";
		var felicieFind = "../../img/felicie/c" + nbLvl + ".png";
		document.getElementById('img').setAttribute('src', nbLvlSrc);
		document.getElementById('character').setAttribute('src', character);
		document.getElementById('charlieFind').setAttribute('src', isCharlie ? charlieFind : felicieFind);
		$(document).ready(function () {
			$("#myBtn").click();
			$("#btn_launch").click(function () {
				$('#errorMessage').html("");
				if(nodeJsConnected){
					$("#loader").addClass('loader');
					$("#btn_launch").prop("disabled",true);
					fetch("http://localhost:9000/api/game/getlaunchrecord/" + nbLvl + "?charlie=" +  isCharlie)
						.then(function (response) {
							return response.json();
						})
						.then(function (data) {
							$("#btn_launch").prop("disabled",false);
							$("#loader").removeClass('loader');
							if (data.status === 'OK') {
								console.log('charlie found')
								document.getElementById("myModal").style.display = "none";
								$('.image-container').removeClass('image-blur');
							}
							else {
								if(data.status.startsWith('LEVEL')) {
									$('#errorMessage').html("Ce niveau n'existe pas !");
								} else {
									$('#errorMessage').html("Erreur lors la la recuperation des donnees (l'eye tracker est il bien configure ?). reessayez");
								}
								console.log('response', data.status)
							}
						})
						.catch(function(error) {
							$("#btn_launch").prop("disabled",false);
							$("#loader").removeClass('loader');
							$('#errorMessage').html("Erreur lors de l'appel du serveur c# (Le serveur est il bien en marche ?)");
						})
				} else {
					$('#errorMessage').html("Erreur de connection au nodejs, redemarrez le server puis reessayez");
				}
			});;
		});

		// Get the modal
		var modal = document.getElementById("myModal");

		// Get the button that opens the modal
		var btn = document.getElementById("myBtn");

		// Get the <span> element that closes the modal
		var span = document.getElementsByClassName("close")[0];

		// When the user clicks the button, open the modal 
		btn.onclick = function () {
			modal.style.display = "block";
		}

		let successModal = document.getElementById("sucessModal");

		const sseSource = new EventSource('http://localhost:3000/success')

		sseSource.onerror = function() {
			nodeJsConnected = false;
		}

		sseSource.addEventListener('message', (e) => {
			if(!nodeJsConnected) {
				nodeJsConnected = true;
			}
			const messageData = e.data
			console.log(messageData)
			if (messageData.includes('success true')) {
				console.log('found')
				successModal.style.display = "block"
				let split = messageData.split(':');
				$('#duration').html('Temps : ' + split[1] + ' Secondes');
				$('#distance').html('Distance : ' + split[2] + ' Pixels');
				addScore(split[2], split[1]);
				sseSource.close()
			}
		})


	</script>

</body>

</html>